from pydantic import BaseModel, ConfigDict, field_validator

from .utils import convert_to_bytes

# class Config(BaseModel):
#     host: str
#     port: int
#     buffer_size: int = 4 * 1024  # 4KB
#     max_size: int = 2 * 1024 * 1024 * 1024  # 2GB
#     max_data: int = 0  # unlimited
#     api_keys = set[str]
#     database = str

#     model_config = ConfigDict(extra='allow')

#     @field_validator('buffer_size', 'max_size', 'max_data')
#     @classmethod
#     def convert_size(cls, value: int | str) -> int:
#         return convert_to_bytes(value)


# TODO
# class DataBase(BaseModel):
#     model_config = ConfigDict(extra='forbid')


class TestDataBody(BaseModel):
    api_key: str
    size: int

    model_config = ConfigDict(extra='forbid')

    @field_validator('size', mode='before')
    @classmethod
    def convert_size(cls, value: str) -> int:
        return convert_to_bytes(value)
